zoukankan      html  css  js  c++  java
  • LeetCode Majority Element

    链接: https://oj.leetcode.com/problems/majority-element/

    LeetCode给的这道题的解答真的不错:

    1. Runtime: O(n2) — Brute force solution: Check each element if it is the majority element.
    2. Runtime: O(n), Space: O(n) — Hash table: Maintain a hash table of the counts of each element, then find the most common one.
    3. Runtime: O(n log n) — Sorting: As we know more than half of the array are elements of the same value, we can sort the array and all majority elements will be grouped into one contiguous chunk. Therefore, the middle (n/2th) element must also be the majority element.
    4. Average runtime: O(n), Worst case runtime: Infinity — Randomization: Randomly pick an element and check if it is the majority element. If it is not, do the random pick again until you find the majority element. As the probability to pick the majority element is greater than 1/2, the expected number of attempts is < 2.
    5. Runtime: O(n log n) — Divide and conquer: Divide the array into two halves, then find the majority element A in the first half and the majority element B in the second half. The global majority element must either be A or B. If A == B, then it automatically becomes the global majority element. If not, then both A and B are the candidates for the majority element, and it is suffice to check the count of occurrences for at most two candidates. The runtime complexity, T(n) = T(n/2) + 2n = O(n log n).
    6. Runtime: O(n) — Moore voting algorithm: We maintain a current candidate and a counter initialized to 0. As we iterate the array, we look at the current element x:
      1. If the counter is 0, we set the current candidate to x and the counter to 1.
      2. If the counter is not 0, we increment or decrement the counter based on whether x is the current candidate.
      After one pass, the current candidate is the majority element. Runtime complexity = O(n).
    7. Runtime: O(n) — Bit manipulation: We would need 32 iterations, each calculating the number of 1's for the ith bit of all n numbers. Since a majority must exist, therefore, either count of 1's > count of 0's or vice versa (but can never be equal). The majority number’s ith bit must be the one bit that has the greater count.

    public class Solution
    {
    	public int majorityElement(int[] num)
    	{
    		int l=num.length;
    		HashMap<Integer,Integer> data=new HashMap<Integer,Integer>();
    		for (int elem : num) {
                  if (data.containsKey(elem)) {
                      data.put(elem, data.get(elem)+1);
                  }
                  else {
                     data.put(elem, 1);
                 }
             }
    		for(int item:data.keySet())
    		{
    			if(data.get(item)>l/2)
    				return item;
    		}
    		return -1;
    	}
    }
    class Solution {
    public:
        int majorityElement(vector<int> &num) {
        int maj;
        int count = 0;
        int n = int(num.size());
        for (int i = 0; i < n; i++){
            if (count == 0){
                maj = num[i];
                count++;
            }
            else if (num[i] == maj){
                count++;
                if (count > n/2) return maj;
            }
            else count--;
        }
        return maj;
        }
    };



  • 相关阅读:
    大文件上传
    zabbix接口
    Vue 在不同的环境使用不同的接口地址
    Vue发布流程
    RabbitMQ集群一些使用细节
    Watcher 系统整体流程图
    监控系统各个模块部署
    deepin安装node和npm最新
    google安装json插件
    数据库访问性能优化 Oracle
  • 原文地址:https://www.cnblogs.com/frankM/p/4399439.html
Copyright © 2011-2022 走看看